using UnityEngine;
using System.Collections;

public class GunTurret : MonoBehaviour {
	
	public GameObject bulletPrefab;
	public GameObject target;
	private float attackRadious = 250;
	private float muzzleVelocity = 50.0f;
	
	void Start()
	{
		target = GameObject.FindWithTag ("Player");
		StartCoroutine(fireWhenReady());
	}
	
	IEnumerator fireWhenReady()
	{
		int burstCounter = 10;
		
		while(target != null) {
			// are we even in range?
			if (Vector3.Distance(target.transform.position, transform.position) < attackRadious) {
				// no, check back in a second
				yield return new WaitForSeconds(1.0f);
				continue;
			}
			// if we are in curst mode, then fire a bullet
			if (burstCounter > 0) {
				//make a new bullet
		 		GameObject bullet = (GameObject)Instantiate(bulletPrefab,transform.position,Quaternion.identity);
				// figure out which way to shoot it
				Vector3 direction = targetLeadingPosition() - transform.position;
				// shoot!
				bullet.rigidbody.AddForce(direction * muzzleVelocity);					
				// wait a moment to 'reload'
				yield return new WaitForSeconds(0.1f);
				// decrement our bullet counter
				burstCounter--;
			} else {
				// no more bullets, wait for 3 seconds, then reload
				yield return new WaitForSeconds(3.0f);				
				burstCounter = 10;
			}
		}
	}



	Vector3 targetLeadingPosition()
	{
		return (target.transform.TransformDirection(Vector3.forward) * (Random.value * 35.0f)) + target.transform.position;
	}
}








